<template>
  <div
    class="SetupPage"
    v-show="
      selectedResourceType !== undefined &&
      selectedResourceType.resourceCreate !== undefined &&
      selectedResourceType.resourceCreate.components !== undefined &&
      selectedResourceType.resourceCreate.components[0] !== undefined
    "
  >
    <coscine-form-group
      v-for="(resourceTypeField, index) in selectedResourceType.resourceCreate
        .components[0]"
      :key="index"
      :mandatory="true"
      :labelFor="resourceTypeField"
      :label="$t(resourceTypeField + 'Label')"
    >
      <SizeSlider
        v-if="resourceTypeField === 'Size'"
        :resource="resource"
        :isProjectOwner="isProjectOwner"
        :projectId="projectId"
        @sliderValChange="setSliderValue"
      />
      <b-form-input
        v-else
        :id="resourceTypeField"
        :type="getInputType(resourceTypeField)"
        :aria-describedby="resourceTypeField + 'Help'"
        v-model="resource.resourceTypeOption[resourceTypeField]"
        @input="
          updateValidity($v.resource.resourceTypeOption[resourceTypeField])
        "
        :state="
          $v.resource.resourceTypeOption[resourceTypeField].$dirty
            ? !$v.resource.resourceTypeOption[resourceTypeField].$error
            : null
        "
        :placeholder="$t(resourceTypeField)"
        :maxlength="
          $v.resource.resourceTypeOption.RepositoryUrl.$params.maxLength !==
            null &&
          $v.resource.resourceTypeOption.RepositoryUrl.$params.maxLength !==
            undefined &&
          $v.resource.resourceTypeOption.RepositoryUrl.$params.maxLength.max !==
            null &&
          $v.resource.resourceTypeOption.RepositoryUrl.$params.maxLength.max !==
            undefined
            ? $v.resource.resourceTypeOption[resourceTypeField].$params
                .maxLength.max
            : -1
        "
        :required="
          $v.resource.resourceTypeOption[resourceTypeField].$params.required !==
          undefined
            ? 'required'
            : false
        "
      />
      <div class="invalid-tooltip">{{ $t(resourceTypeField + "Help") }}</div>
    </coscine-form-group>
  </div>
</template>

<script lang="ts">
import Vue, { PropType } from "vue";
import { ProjectApi, BlobApi } from "@coscine/api-connection";
import { GuidUtil, LinkUtil } from "@coscine/app-util";
import { CoscineFormGroup } from "@coscine/component-library";
import "@coscine/component-library/dist/index.css";

import SizeSlider from "./SizeSlider.vue";

import { validationMixin } from "vuelidate";
import {
  required,
  minLength,
  maxLength,
  integer,
} from "vuelidate/lib/validators";

const formSettings = {
  BucketName: {
    required,
    minLength: minLength(3),
    maxLength: maxLength(63),
  },
  AccessKey: {
    required,
    maxLength: maxLength(200),
  },
  SecretKey: {
    required,
    maxLength: maxLength(200),
  },
  ResourceUrl: {
    required,
    maxLength: maxLength(200),
  },
  RepositoryNumber: {
    required,
    integer,
  },
  RepositoryUrl: {
    required,
    maxLength: maxLength(500),
  },
  Token: {
    required,
    maxLength: maxLength(100),
  },
} as any;

export default Vue.extend({
  mixins: [validationMixin],
  name: "SetupPage",
  components: {
    CoscineFormGroup,
    SizeSlider,
  },
  validations() {
    const resource = { resourceTypeOption: {} } as any;
    for (const field of this.formFields) {
      resource.resourceTypeOption[field as string] =
        formSettings[field as string];
    }
    return { resource };
  },
  methods: {
    setSliderValue(val: any) {
      this.$emit("sliderValChange", val);
    },
    getInputType(resourceTypeField: string) {
      if (
        resourceTypeField !== "AccessKey" &&
        resourceTypeField !== "SecretKey" &&
        resourceTypeField !== "Token"
      ) {
        return "text";
      }
      return "password";
    },
    updateValidity(validationObject: any) {
      validationObject.$touch();
    },
    validateResource() {
      if (this.formFields.length === 0) {
        return true;
      }
      if (this.formFields.length === 1 && this.formFields[0] === "Size") {
        return this.sliderValue >= 0 && !isNaN(this.sliderValue);
      }
      this.$v.$touch();
      if (!this.$v.$invalid) {
        this.$emit("waitingForResponse", true);

        BlobApi.isResourceValid(
          this.resource,
          (response: any) => {
            this.$emit("waitingForResponse", false);
            if (!this.$v.$invalid) {
              return true;
            }
          },
          (error: any) => {
            this.$emit("waitingForResponse", false);
            return false;
          }
        );
      } else {
        return false;
      }
    },
  },
  props: {
    resource: Object,
    isProjectOwner: Boolean,
    selectedResourceType: Object,
    formFields: Array as PropType<string[]>,
    projectId: String,
    sliderValue: Number,
  },
});
</script>
